var Sip = function() {

}

Sip.prototype.register = function(settings, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'register', [ settings ]);
};

Sip.prototype.unregister = function(success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'unregister', []);
};

Sip.prototype.call = function(number, callId, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'call', [ {
      'number' : number,
      'callId' : callId
   } ]);
};

Sip.prototype.acceptIncall = function(callId, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'acceptIncall', [ {
      'callId' : callId
   } ]);
};

Sip.prototype.setCallStateWatch = function(callId, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'setCallStateWatch', [ callId ]);
};

Sip.prototype.stopCallStateWatch = function(callId) {
   var success = function() {
   };
   var fail = function(args) {
   };
   return cordova.exec(function(args) {
      this.success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'stopCallStateWatch', [ callId ]);
};

Sip.prototype.hangup = function(callId) {
   var success = function(args) {
   };
   var fail = function(args) {
   };
   return cordova.exec(function(args) {
      this.success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'hangup', [ callId ]);
};

Sip.prototype.muteMic = function(mute, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'muteMic', [ mute ]);
};

Sip.prototype.enableSpeaker = function(speaker, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'enableSpeaker', [ speaker ]);
};

Sip.prototype.getRegisterStatus = function(success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getRegisterStatus', []);
};

Sip.prototype.echoCalibration = function(success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'echoCalibration', []);
};

Sip.prototype.enableProximitySensor = function() {
   var success = function() {
   };
   var fail = function(args) {
   };
   return cordova.exec(function(args) {
      this.success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'enableProximitySensor', []);
};

Sip.prototype.disableProximitySensor = function() {
   var success = function() {
   };
   var fail = function(args) {
   };
   return cordova.exec(function(args) {
      this.success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'disableProximitySensor', []);
};

Sip.prototype.sendChatMessage = function(sipAccount, phoneNumber, message, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'sendChatMessage', [ sipAccount, phoneNumber, message ]);
};

Sip.prototype.getConversationsList = function(success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getConversationsList', [ ]);
};

Sip.prototype.getConversation = function(sipAccount, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getConversation', [ sipAccount ]);
};

Sip.prototype.getUnreadMessages = function(sipAccount, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getUnreadMessages', [ sipAccount ]);
};

Sip.prototype.getChatHistory = function(sipAccount, success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getChatHistory', [ sipAccount ]);
};

Sip.prototype.setChatListener = function(messageCallback) {
   return cordova.exec(function(message) {
      messageCallback(message);
   }, function(error) {
      // ignore
   }, 'Sip', 'setChatListener', [ ]);
};

Sip.prototype.markConversationAsRead = function(sipAccount) {
   return cordova.exec(function(result) {
      // ignore
   }, function(error) {
      // ignore
   }, 'Sip', 'markConversationAsRead', [ sipAccount ]);
};

Sip.prototype.getUnreadMessageCount = function(success, fail) {
   return cordova.exec(function(args) {
      success(args);
   }, function(args) {
      fail(args);
   }, 'Sip', 'getUnreadMessageCount', [ ]);
};

cordova.addConstructor(function() {
   window.sip = new Sip();

   // backwards compatibility
   window.plugins = window.plugins || {};
   window.plugins.sip = window.sip;
});